﻿
; XIncludeFile "C:\Users\sillica\Documents\Programming\Modules\Module_my_common_procs.pbi"
; UseModule  my_common_procs

DeclareModule SaveSVDFormMap
	Declare CreateGadgets(Model.s, bFromLoadedForm.b = 0)	
	Global sClip.s = "", sClip1.s = ""
	
	Declare SaveSVDFormMap(sFileName.s)
	Declare LoadSVDFormMap(sFileName.s)
	
EndDeclareModule

Module SaveSVDFormMap
	
	Procedure LoadSVDFormMap(sFileName.s)
	CallDebugger
		Global NewMap m_LoadedFormData.SVDesigner::SVDGadget()
		Protected iPos.i
		If ReadFile(0, sFileName)	
			If ParseXML(0, ReadString(0)) And XMLStatus(0) = #PB_XML_Success
				ClearMap(SVDesigner::SVDListGadget())
				ExtractXMLMap(MainXMLNode(0), m_LoadedFormData())
				CopyMap(m_LoadedFormData(), SVDesigner::SVDListGadget())
				If ParseXML(1, ReadString(0)) And XMLStatus(1) = #PB_XML_Success
					ClearMap(SVDesigner::SVDListParentGadget())
					ExtractXMLMap(MainXMLNode(1), SVDesigner::SVDListParentGadget())
				Else
					Debug XMLError(1)
				EndIf
			Else
				Debug XMLError(0)
			EndIf
			CloseFile(0)
			CallDebugger
			With m_LoadedFormData()
			ForEach m_LoadedFormData()
				CreateGadgets(\Model, #True)
			Next
			EndWith
		EndIf
	EndProcedure
	
	Procedure SaveSVDFormMap(sFileName.s)		
		If (MapSize(SVDesigner::SVDListGadget()) > 1) And CreateXML(0) 
			InsertXMLMap(RootXMLNode(0), SVDesigner::SVDListGadget())
			sClip =  ComposeXML(0)
			If (MapSize(SVDesigner::SVDListParentGadget()) > 0) And CreateXML(1)
				InsertXMLMap(RootXMLNode(1), SVDesigner::SVDListParentGadget())
				sClip1 =  ComposeXML(1)
			EndIf	
		EndIf
		If sClip <> #Null$ Or sClip1 <> #Null$
			Debug GetCurrentDirectory()
			If CreateFile(0, sFileName + ".svdf")
				WriteStringN(0, sClip)
				WriteStringN(0, sClip1)
				CloseFile(0)
			EndIf
		EndIf	
	EndProcedure	
EndModule	
; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 5
; Folding = -
; EnableAsm
; EnableXP
; EnablePurifier